#include "irc.h"
#include "cfg.h"
#include <time.h>
IRCC_client client;

void die(char *msg) {
	puts(msg);
	IRCC_close(&client);
	exit(1);
}

struct tm GetTime(void) {
	time_t t = time(NULL);
	return *localtime(&t);
}

char *GetFilename(void) {
	//Get filename + date
	struct tm tm = GetTime();

	size_t filename_size = strlen(client.channel + 1) + (sizeof(tm.tm_year) * 3) + strlen(EXT) + 3;
	char *filename = malloc(filename_size + 1);
	if (filename == NULL)
		die("malloc returned NULL");

	snprintf(filename, filename_size, "%s-%d-%d-%d%s", client.channel + 1, tm.tm_year + 1900, tm.tm_mon, tm.tm_mday, EXT);
	return filename;
}

void WriteToFile(void) {
	if (client.msg[1] == '.' || client.channel[0] != '#')
		return;

	char *filename = GetFilename();
	FILE *fp = fopen(filename, "a");
	free(filename);

	if (fp == NULL) {
		printf("Cant open file %s\n", client.channel);
		return;
	}

	fprintf(fp, FORMAT, client.nick, client.msg);
	fclose(fp);
}

void recvinfo(void) {
	while (1) {
		unsigned int irc_status = IRCC_recv(&client);
		if (irc_status == IRCC_DISCONNECTED)
			die("Disconnected");

		else if (client.nick != NULL && client.channel != NULL && client.msg != NULL && irc_status == IRCC_PRIVMSG)
			WriteToFile();
	}
}

int main(void) {
	if (chdir(DIR))
		die("Cant chdir");

	//512 - size of raw buffer (max irc)
	IRCC_init(&client);
	int status = IRCC_connect(&client, HOST, PORT);
	if (status == IRCC_ERROR)
		die("Conn refused");

	//Register
	IRCC_register(&client, NICK);

	//Recv motd and join in channel
	sleep(5);
	for (size_t i = 0; i < sizeof(channels) / sizeof(struct CHANNEL); i++)
		IRCC_join(&client, channels[i].channel, channels[i].key);

	for (size_t i = 0; i < sizeof(send_after_join) / sizeof(char *); i++) {
		if (send_after_join[i] == NULL)
			break;

		send(client.socket, send_after_join[i], strlen(send_after_join[i]), 0);
	}

	recvinfo();
}

